REAL*8 FUNCTION    costheta(slope,aspect,solarazimuth,solarelevation)
USE nrtype
IMPLICIT NONE

	REAL (DP), 	INTENT(IN)	:: slope, &
					   aspect, &
					   solarazimuth, &
					   solarelevation
					   
	costheta=COS(slope)*SIN(solarelevation)+(SIN(slope)*COS(solarelevation)* &
		 COS(solarazimuth-aspect))
	IF (costheta .LT. 0._dp) costheta=0._dp
	
END FUNCTION costheta
