SUBROUTINE layeraccount(massbal,cum_pdds,zseasonabl,zsnowday,depth_index,i,j)
USE params
USE nrtype
IMPLICIT NONE

REAL(DP),	DIMENSION(1:nlat,1:nlong,1:nlayers),	INTENT(INOUT)	:: massbal, &
												   cum_pdds, &
												   zseasonabl, &
												   zsnowday

INTEGER(I4B),					INTENT(INOUT)	:: depth_index
INTEGER(I4B),					INTENT(IN   )	:: i,j



REAL(DP)										:: layers_snow,layers_ablation

INTEGER(I4B)									:: k



		IF (((massbal(i,j,depth_index)) .LE. 0._dp) .AND. (depth_index .GT. 2)) THEN
			DO k=(depth_index-1),2,-1
				layers_snow=SUM(massbal(i,j,k:depth_index))
				IF (layers_snow .GT. 0._dp) THEN
					layers_ablation=SUM(zseasonabl(i,j,k:depth_index))
					depth_index=k
					massbal(i,j,(depth_index+1):nlayers)=0._dp
					cum_pdds(i,j,(depth_index+1):nlayers)=1._dp
					zseasonabl(i,j,(depth_index+1):nlayers)=0._dp
					massbal(i,j,depth_index)=layers_snow
					cum_pdds(i,j,depth_index)=cum_pdds(i,j,depth_index)
					zseasonabl(i,j,depth_index)=zseasonabl(i,j,depth_index)+layers_ablation
					EXIT
				ENDIF
				IF ((k .EQ. 2) .AND. layers_snow .LE. 0) THEN
					layers_ablation=SUM(zseasonabl(i,j,k:nlayers))
					depth_index=1
					massbal(i,j,depth_index)=massbal(i,j,depth_index)+layers_snow
					cum_pdds(i,j,depth_index)=cum_pdds(i,j,depth_index)
					zseasonabl(i,j,depth_index)=zseasonabl(i,j,depth_index)+layers_ablation
					massbal(i,j,2:nlayers)=0._dp
					cum_pdds(i,j,2:nlayers)=0.1_dp
					zseasonabl(i,j,2:nlayers)=0._dp
					zsnowday(i,j,2:nlayers)=0._dp
				ENDIF
			ENDDO
		ELSEIF ((massbal(i,j,depth_index) .LE. 0._dp) .AND. (depth_index .EQ. 2)) THEN
			depth_index=depth_index-1
			massbal(i,j,(depth_index))=massbal(i,j,(depth_index))+massbal(i,j,(depth_index+1))
			cum_pdds(i,j,(depth_index))=cum_pdds(i,j,(depth_index))
			zseasonabl(i,j,(depth_index))=zseasonabl(i,j,(depth_index))+zseasonabl(i,j,(depth_index+1))
			massbal(i,j,(depth_index+1):nlayers)=0._dp
			cum_pdds(i,j,(depth_index+1):nlayers)=1._dp
			zseasonabl(i,j,(depth_index+1):nlayers)=0.00_dp
			zsnowday(i,j,(depth_index+1):nlayers)=0._dp
		ENDIF

END SUBROUTINE layeraccount
