REAL*8 FUNCTION psi(z,molength)
USE nrtype
IMPLICIT NONE

		REAL(DP)		:: z,molength,x,z_over_l



		z_over_l=z/molength
		IF (z_over_l .GT. 0._dp) THEN	!Stable
			psi=5._dp
		ELSE							!Unstable
			x=(1-(16._dp*z_over_l))**0.25_dp
			psi=-2._dp*LOG((1+x)/2._dp)-LOG((1+x**2)/2._dp)+2._dp*ATAN(x)-3.14159265359_dp/2._dp
		ENDIF

END FUNCTION psi

	