SUBROUTINE	grainsize(age,melt_frac,r_vis,r_nir)
USE nrtype
USE params
IMPLICIT NONE

	REAL(DP),			INTENT(IN   )	:: age
	REAL(DP),			INTENT(IN   )	:: melt_frac
	REAL(DP),			INTENT(  OUT)	:: r_vis
	REAL(DP),			INTENT(  OUT)	:: r_nir

	REAL(DP)							:: r_nir_o, &
										   r_vis_o, &
										   r_ng_nir, &
										   r_ng_vis, &
										   g_growth, &
										   contam=1._dp

	
	r_nir_o=SQRT(r_o)				
	r_vis_o=contam*r_nir_o
	r_ng_nir=SQRT(r_max-r_o)
	r_ng_vis=r_ng_nir*contam
	g_growth=COS(0.5*ACOS((age-t_max/2)/(age+t_max/2)))
	r_vis=r_vis_o+r_ng_vis*g_growth
	r_nir=r_nir_o+r_ng_nir*g_growth
	r_vis=r_vis*(1._dp + melt_frac)
	r_nir=r_nir*(1._dp + melt_frac)						
END SUBROUTINE grainsize