SUBROUTINE indexx(n,arr,indx)
USE nrtype
IMPLICIT NONE

INTEGER(I4B),				INTENT(IN   )	:: n
REAL(DP),	DIMENSION(n),		INTENT(IN   )	:: arr
INTEGER(I4B),	DIMENSION(n),		INTENT(  OUT)	:: indx

REAL(DP)											:: a
													   

INTEGER(I4B),	PARAMETER				:: m=7
INTEGER(I4B),	PARAMETER				:: nstack=50

INTEGER(I4B)						:: i,indxt,ir,itemp,j,jstack,k,l
INTEGER(I4B),	DIMENSION(nstack)			:: istack=0




	DO j=1,n,1
	    indx(j)=j
	END DO
	jstack=0
	l=1
	ir=n
1	IF (ir-l .LT. m) THEN
	    DO j=(l+1),ir
		indxt=indx(j)
		a=arr(indxt)
		DO i=j-1,l,-1
		    IF (arr(indx(i)) .LE. a) GOTO 2
		    indx(i+1)=indx(i)
		END DO
		i=l-1
2		indx(i+1)=indxt
	    END DO
	    IF (jstack .EQ. 0) RETURN
	    ir=istack(jstack)
	    l=istack(jstack-1)
	    jstack=jstack-2
	ELSE
	    k=(l+ir)/2
	    itemp=indx(k)
	    indx(k)=indx(l+1)
	    indx(l+1)=itemp
	    IF (arr(indx(l)) .GT. arr(indx(ir))) THEN
		itemp=indx(l)
		indx(l)=indx(ir)
		indx(ir)=itemp
	    END IF
	    IF (arr(indx(l+1)) .GT. arr(indx(ir))) THEN
		itemp=indx(l+1)
		indx(l+1)=indx(ir)
		indx(ir)=itemp
	    END IF
	    IF (arr(indx(l)) .GT. arr(indx(l+1))) THEN
		itemp=indx(l)
		indx(l)=indx(l+1)
		indx(l+1)=itemp
	    END IF
	    i=l+1
	    j=ir
	    indxt=indx(l+1)
	    a=arr(indxt)
3	    CONTINUE
	    i=i+1
	    IF (arr(indx(i)) .LT. a) GOTO 3
4	    CONTINUE
	    j=j-1
	    IF (arr(indx(j)) .GT. a) GOTO 4
	    IF (j .LT. i) GOTO 5
	    itemp=indx(i)
	    indx(i)=indx(j)
	    indx(j)=itemp
	    GOTO 3
5	    indx(l+1)=indx(j)
	    indx(j)=indxt
	    jstack=jstack+2
	    IF (jstack .GT. nstack) THEN
		PRINT *,"nstack too small in index"
		STOP
	    END IF
	    IF ((ir-i+1) .GE. (j-l)) THEN
		istack(jstack)=ir
		istack(jstack-1)=i
		ir=j-1
	    ELSE
		istack(jstack)=j-1
		istack(jstack-1)=l
		l=i
	    END IF
	END IF
	GOTO 1
END SUBROUTINE indexx
